Package org.gradle.api.file

## Interface FileCollection

- All Superinterfaces:
    `AntBuilderAware`, `Buildable`, `java.lang.Iterable<java.io.File>`
  All Known Subinterfaces:
    `AntlrSourceDirectorySet`, `ConfigurableFileCollection`, `ConfigurableFileTree`, `Configuration`, `ConsumableConfiguration`, `DependencyScopeConfiguration`, `FileTree`, `GroovySourceDirectorySet`, `ResolvableConfiguration`, `ScalaSourceDirectorySet`, `SourceDirectorySet`, `SourceSetOutput`

      public interface FileCollection
      extends java.lang.Iterable<java.io.File>, AntBuilderAware, Buildable

  A `FileCollection` represents a collection of file system locations which you can query in certain ways. A file collection is can be used to define a classpath, or a set of source files, or to add files to an archive.

  There are no methods on this interface that allow the contents of the collection to be modified. However, there are a number of sub-interfaces, such as `ConfigurableFileCollection` that allow changes to be made.

  A file collection may contain task outputs. The file collection tracks not just a set of files, but also the tasks that produce those files. When a file collection is used as a task input property, Gradle will take care of automatically adding dependencies between the consuming task and the producing tasks.

  You can obtain a `FileCollection` instance using `Project.files(java.lang.Object...)`.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static class` | `FileCollection.AntType` | Ant types which a `FileCollection` can be mapped to.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.lang.Object` | `addToAntBuilder​(java.lang.Object builder, java.lang.String nodeName)` | Adds this collection to an Ant task as a nested node.
    `void` | `addToAntBuilder​(java.lang.Object builder, java.lang.String nodeName, FileCollection.AntType type)` | Adds this collection to an Ant task as a nested node.
    `boolean` | `contains​(java.io.File file)` | Determines whether this collection contains the given file.
    `FileCollection` | `filter​(Closure filterClosure)` | Restricts the contents of this collection to those files which match the given criteria.
    `FileCollection` | `filter​(Spec<? super java.io.File> filterSpec)` | Restricts the contents of this collection to those files which match the given criteria.
    `FileTree` | `getAsFileTree()` | Converts this collection to a `FileTree`, if not already.
    `java.lang.String` | `getAsPath()` | Returns the contents of this collection as a platform-specific path.
    `Provider<java.util.Set<FileSystemLocation>>` | `getElements()` | Returns the contents of this file collection as a `Provider` of `FileSystemLocation` instances.
    `java.util.Set<java.io.File>` | `getFiles()` | Returns the contents of this collection as a `Set`.
    `java.io.File` | `getSingleFile()` | Returns the content of this collection, asserting it contains exactly one file.
    `boolean` | `isEmpty()` | Returns true if this collection is empty.
    `FileCollection` | `minus​(FileCollection collection)` | Returns a `FileCollection` which contains the difference between this collection and the given collection.
    `FileCollection` | `plus​(FileCollection collection)` | Returns a `FileCollection` which contains the union of this collection and the given collection.

    - ### Methods inherited from interface org.gradle.api.Buildable

      `getBuildDependencies`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, iterator, spliterator`

- - ### Method Detail

    - #### getSingleFile

          java.io.File getSingleFile()
                              throws java.lang.IllegalStateException

      Returns the content of this collection, asserting it contains exactly one file.
      Returns:
        The file.
      Throws:
        `java.lang.IllegalStateException` - when this collection does not contain exactly one file.

    - #### getFiles

          java.util.Set<java.io.File> getFiles()

      Returns the contents of this collection as a `Set`. The contents of a file collection may change over time.

      Note that this method returns `File` objects that represent locations on the file system. These `File` objects do not necessarily refer to regular files. Depending on the implementation of this file collection and how it has been configured, the returned set may contain directories, or missing files, or any other kind of file system element.

      Returns:
        The files. Returns an empty set if this collection is empty.

    - #### contains

          boolean contains​(java.io.File file)

      Determines whether this collection contains the given file. Generally, this method is more efficient than calling `getFiles().contains(file)`.
      Parameters:
        `file` - The file to check for.
      Returns:
        true if this collection contains the given file, false otherwise.

    - #### getAsPath

          java.lang.String getAsPath()

      Returns the contents of this collection as a platform-specific path. This can be used, for example, in an Ant <path> element.
      Returns:
        The path. Returns an empty string if this collection is empty.

    - #### plus

          FileCollection plus​(FileCollection collection)

      Returns a `FileCollection` which contains the union of this collection and the given collection. The returned collection is live, and tracks changes to both source collections.

      You can call this method in your build script using the `+` operator.

      Parameters:
        `collection` - The other collection. Should not be null.
      Returns:
        A new collection containing the union.

    - #### minus

          FileCollection minus​(FileCollection collection)

      Returns a `FileCollection` which contains the difference between this collection and the given collection. The returned collection is live, and tracks changes to both source collections.

      You can call this method in your build script using the `-` operator.

      Parameters:
        `collection` - The other collection. Should not be null.
      Returns:
        A new collection containing the difference.

    - #### filter

          FileCollection filter​(Closure filterClosure)

      Restricts the contents of this collection to those files which match the given criteria. The filtered collection is live, so that it reflects any changes to this collection.

      The given closure is passed the @{link File} as a parameter, and should return a boolean value. The closure should return `true` to include the file in the result and `false` to exclude the file from the result.

      Parameters:
        `filterClosure` - The closure to use to select the contents of the filtered collection.
      Returns:
        The filtered collection.

    - #### filter

          FileCollection filter​(Spec<? super java.io.File> filterSpec)

      Restricts the contents of this collection to those files which match the given criteria. The filtered collection is live, so that it reflects any changes to this collection.

      Parameters:
        `filterSpec` - The criteria to use to select the contents of the filtered collection.
      Returns:
        The filtered collection.

    - #### isEmpty

          boolean isEmpty()

      Returns true if this collection is empty. Generally, calling this method is more efficient than calling `getFiles().isEmpty()`.
      Returns:
        true if this collection is empty, false otherwise.

    - #### getAsFileTree

          FileTree getAsFileTree()

      Converts this collection to a `FileTree`, if not already. For each file in this collection, the resulting file tree will contain the source file at the root of the tree. For each directory in this collection, the resulting file tree will contain all the files under the source directory.

      The returned `FileTree` is live, and tracks changes to this file collection and the producer tasks of this file collection.

      Returns:
        this collection as a `FileTree`. Never returns null.

    - #### getElements

          Provider<java.util.Set<FileSystemLocation>> getElements()

      Returns the contents of this file collection as a `Provider` of `FileSystemLocation` instances. See `getFiles()` for more details.

      The returned `Provider` is live, and tracks changes to this file collection and the producer tasks of this file collection.

      Since:
        5.6

    - #### addToAntBuilder

          void addToAntBuilder​(java.lang.Object builder,
                               java.lang.String nodeName,
                               FileCollection.AntType type)

      Adds this collection to an Ant task as a nested node. The given type determines how this collection is added:
      - `FileCollection.AntType.MatchingTask`: adds this collection to an Ant MatchingTask. The collection is converted to a set of source directories and include and exclude patterns. The source directories as added as an Ant Path with the given node name. The patterns are added using 'include' and 'exclude' nodes.
      - `FileCollection.AntType.FileSet`: adds this collection as zero or more Ant FileSets with the given node name.
      - `FileCollection.AntType.ResourceCollection`: adds this collection as zero or more Ant ResourceCollections with the given node name.
      You should prefer using `FileCollection.AntType.ResourceCollection`, if the target Ant task supports it, as this is generally the most efficient. Using the other types may involve copying the contents of this collection to a temporary directory.
      Parameters:
        `builder` - The builder to add this collection to.
        `nodeName` - The target node name.
        `type` - The target Ant type

    - #### addToAntBuilder

          java.lang.Object addToAntBuilder​(java.lang.Object builder,
                                           java.lang.String nodeName)

      Adds this collection to an Ant task as a nested node. Equivalent to calling `addToAntBuilder(builder, nodeName,AntType.ResourceCollection)`.
      Specified by:
        `addToAntBuilder` in interface `AntBuilderAware`